//CWindow.cpp     //30 lines of code
#define MYDEBUG
#ifndef UNICODE
#define UNICODE
#define _UNICODE
#endif
#include <windows.h>
#include <tchar.h>
#include <cstdio>
#include "CWindow.h"
#ifdef MYDEBUG
extern FILE* fp;
#endif

CWindow::CWindow
(
 int iShow,
 LPCTSTR szClassName,
 LPCTSTR szCaption,
 DWORD dwStyle,
 int x,
 int y,
 int iWidth,
 int iHeight,
 HWND hParent,
 HMENU hMenu,
 HINSTANCE hIns,
 void* lpCreateParams
)
{
 #ifdef MYDEBUG
 fprintf(fp,"  Entering CWindow Constructor!\n");
 #endif
 this->m_hWnd=CreateWindowEx(0,szClassName,szCaption,dwStyle,x,y,iWidth,iHeight,hParent,(HMENU)hMenu,hIns,lpCreateParams);
 this->m_hInst=hIns;
 ShowWindow(this->m_hWnd,iShow);
 UpdateWindow(this->m_hWnd);
 #ifdef MYDEBUG
 fprintf(fp,"    this          = %u\n",(unsigned)this);
 fprintf(fp,"    this->m_hInst = %u\n",(unsigned)this->m_hInst);
 fprintf(fp,"    this->m_hWnd  = %u\n",(unsigned)this->m_hWnd);
 fprintf(fp,"  Leaving CWindow Constructor!\n\n");
 #endif
}

WPARAM CWindow::Run(void)
{
 MSG msg;

 while(GetMessage(&msg,NULL,0,0))
 {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
 }

 return msg.wParam;
}

CWindow::~CWindow(void)
{
 #ifdef MYDEBUG
 fprintf(fp,"  Executed CWindow Destructor!\n");
 #endif
}
